;-------------------------------------------------------
;	Iron Spring PL/I Runtime Library Version 0.5
;	   Distributed under the Gnu LGPL License
;
;	_pli_Froma - PL/I runtime support routines
;       Version 0.6 Alpha -- June, 2008
;       Copyright Peter Flass
;	This module implements 'fromalien' linkage.
;
;	PL/I linkage conventions require the address of the 
;	PGT in EDI and the static backchain in ESI.
;	This procedure is called at the entry to a 'fromalien'
;	procedure in place of '_pli_SFI' to save the non-PL/I
;	caller's EDS and ESI, set up the required values, and
;	then call '_pli_SFI' to initialize the DSA for the
;	called procedure.
;
;	NOTE: EDI and ESI are stored in non-standard locations
;	of EBP-36 (EDI) and EBP-40 (ESI).  _pli_SFI has no 
;	knowledge of the existence of these fields, but will
;	not normally touch them.
;	*** If code is ever installed to zero the called
;	    program's automatic storage, these have to
;	    be handled specially. ***
;
;	To Do:
;	
;       Modifications:
;	
;-------------------------------------------------------
	.486P
	.model flat,syscall

	.code
_pli_code equ $
        public _pli_FromA

	extern _pli_PGT:near
	include framedef.inc
;------------------------------------------------+
;  Unique Stack Data for _pli_FromA              |
;------------------------------------------------+
frm_loc equ     frm_bos		; Start of locals for _pli_Init
loc_edi equ     frm_loc-4	; Caller's EDI
loc_esi equ	frm_loc-8	; Caller's ESI
loc_end equ     frm_loc-28	; end of local stack
loc_len equ     frm_loc-loc_end	; Length of local stack
; 
;-----------------------------------------------------
;	_pli_FromA:  PL/I 'fromalien' linkage
;-----------------------------------------------------
	db   '_pli_FromA'	; Entry point name
	db   10			; Length of name
_pli_FromA: 
	mov  loc_esi[esp],esi	; Save caller's ESI
	mov  loc_edi[esp],edi	;   and EDI
	mov  esi,0		; No static backchain
	mov  edi,offset _pli_PGT; Addr(PGT) in EDI
	jmp  dword ptr 0[edi]	; call _pli_SFI
;
;	Return is to user's code that called _pli_FromA
;	control never returns here.
;
	end
