;-------------------------------------------------------
;	Iron Spring PL/I Runtime Library Version 0.5
;	   Distributed under the Gnu LGPL License
;
;	_pli_Start - PL/I runtime support routines
;       Version 0.1 Alpha -- Dec, 2003
;       Copyright Peter Flass
;
;	PLISTART is statically linked with the user's .EXE.
;	It's function is to pass the address of the Global
;	Data Structure to _pli_Init, which performs the
;	actual initialization.
;
;	To Do:
;	  . Get thread local storage for addr(TDA).
;	  . Add country info.
;	
;       Modifications:
;         2008-10-01 - Fix get and put entry variables in gbl      20081001
;                      so that get and put get condition chain     20081001
;         2008-05-21 - Fix startup logic for DLLs		   20080521
;	  2004-06-09 - Add 'maj_task_TDA'
;	
;-------------------------------------------------------
	.486P
	.model flat,syscall
        public _pli_Start
DGROUP	group  DATA32			;			   20080521

	.code
_pli_code equ $
	extern _pli_Init:near
	extern _pli_Main:near
	extern _pli_IIC:near
	extern _pli_Tabs:near		;			     @00003
;	WXTERNs for GET and PUT routines
	extern _pli_Get(_pli_IIC):near
	extern _pli_Put(_pli_IIC):near
; 
;-----------------------------------------------------
;	_pli_Start:  Initialize PL/I MAIN procedure
;-----------------------------------------------------
	byte   '_pli_Start'		; Entry point name
	byte   10			; Length of name
_pli_Start:
        mov  ebp,esp                    ; Save DSA addr            20081001
	lea  eax,maj_task_TDA		; Load initial TDA address 20040609
	mov  gbl_TDA_anchor,eax  	; Store into GBL           20040609
        mov  gbl_get_ep+4,ebp           ; Set backchain            20081001
        mov  gbl_put_ep+4,ebp           ;  "     "                 20081001
	lea  eax,_pli_global_data
	jmp  _pli_Init

	.data
_pli_data equ $
;
;------------------------------------------------+
;	Global Data Area                         |
;------------------------------------------------+
	align	4
_pli_global_data:
gbl_data_size	dword	gbl_data_len		; Length of global data
gbl_return_code	dword	0			; Return Code
gbl_main_ep     dword   _pli_Main               ; Address of MAIN       20080521
		dword	0			; (second word of entry)20080521
gbl_get_ep	dword	_pli_Get		; Address of GET routine
		dword	0			; (second word of entry)
gbl_put_ep	dword	_pli_Put		; Address of PUT routine
		dword	0			; (second word of entry)
		dword	0			; (reserved)
		dword	0			; "
gbl_User1	dword	0			; User field 1
gbl_User2	dword	0			; User Field 2
gbl_TDA_anchor	dword   0			; addr(major_task_TDA)
gbl_alloc_cnt	dword   0			; Allocation count
gbl_plitabs_addr dword	_pli_Tabs		; Address of PLITABS	20080522
;------- to add ----------------------------------------------------------------
;		Add country info?
;		Add addr(TDA_address) [TDA_address is stored in
;		  thread local storage.
;-------------------------------------------------------------------------------
		dword	9 DUP(0)		; (reserved, for now)
gbl_data_len	equ	$-_pli_global_data	; Area length
;		Expansion for _pli_global_data goes here
;
maj_task_TDA	dword  24 DUP(0)		; Major task TDA (96 bytes) 20040609

       	.stack  16384				; Minimal stack size for startup

 	end _pli_Start
